//-----------------------------------------
// Morze
//   
//
// Author:   
// H-page: http://raxp.radioliga.com
// C : win32
//-----------------------------------------

unit mz;

interface

uses
  windows,SysUtils,Classes, Controls, Forms,
  gen, Graphics, ExtCtrls,to_tray,messages,StdCtrls, Menus;

type
  TForm1 = class(TForm)
    Image1: TImage;
    m1: TEdit;
    Shape1: TShape;
    pm1: TPopupMenu;
    O1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    Timer1: TTimer;

    procedure Image1Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure m1Change(Sender: TObject);
    procedure m1KeyPress(Sender: TObject; var Key: Char);
    procedure m1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure O1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);

  public
    { Public declarations }
    procedure seeh;
    //  
    procedure iconmsg(var Mess:TMessage);message TRAY_CALLBACK;
    procedure DefaultHandler(var M); override;
  end;

//---
const letters= 'abwgdevzijklmnoprstufhcqyx1234567890,.;:?\"@()!-';
      codes: array[0..79]of string =('.-','-...','.--','--.','-..','.','...-','--..','..','.---',  '.-','-...','.--','--.','-..','.','...-','--..','..','.---', //ABWGDEVZIJ 
                                     '-.-','.-..','--','-.','---','.--.','.-.','...','-','..-',	 '-.-','.-..','--','-.','---','.--.','.-.','...','-','..-',     //KLMNOPRSTU 
                                     '..-.','....','-.-.','---.','----','--.-',  '..-.','....','-.-.','---.','----','--.-','-.--','-..-','..-..','..--',        //FHC  QYX    
                                     '.-.-',                                                                                                                    //
                                     '.----','..---','...--','....-','.....','-....','--...','---..','----.','-----',                                           //1234567890
                                     '.-.-.-','......','-.-.-','---...','..--..','-..-.','.-..-.','.----.','-.--.-','--..--','-.--.-','--..--',                 //,.;:?'' () !
                                     '-....-'                                                                                                                   //-
                                     );
      keys= '1234567890*#abcd';
      dtmfv: array[0..15]of integer =(697,697,697,770,770,770,852,852,852,941,941,941,697,770,852,941);
      dtmfg: array[0..15]of integer =(1209,1336,1471,1209,1336,1471,1209,1336,1471,1336,1209,1471,1633,1633,1633,1633);
//---

var Form1 : TForm1;
    slovo : string;
    fl_see: boolean;
    Gen1: TGen;
    i: integer;

implementation
{$R *.dfm}

procedure tform1.seeh;
begin
 fl_see:= not fl_see;
 if not fl_see then begin
  show; setforegroundwindow(Handle)
 end else hide
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
 gen1.ResetAM;
 gen1.Prepare;
 gen1.Frequency:= 500;

 INC(I); if i> length(slovo) then begin
   timer1.Enabled:= false;
   i:= 0
 end;

 if slovo[i]='.' then begin gen1.Duration:=100;  gen1.Play end;
 if slovo[i]='-' then begin gen1.Duration:= timer1.Interval; gen1.Play end

end;

procedure Tform1.iconmsg(var Mess:TMessage);
 procedure refr_tn;
 begin
 end;
var Mouse: TMouse;
begin
 case Mess.lParam of
  WM_LBUTTONDBLCLK : seeh;//     .
  WM_LBUTTONDOWN   : seeh;//   
  //WM_LBUTTONUP     : //   
  //WM_MBUTTONDBLCLK : //    
  //WM_MBUTTONDOWN   : //   
  //WM_MBUTTONUP     : //   
  //WM_MOUSEMOVE     : // 
  //WM_MOUSEWHEEL    : //  
  //WM_RBUTTONDBLCLK : //   
  //WM_RBUTTONDOWN   : //   
  WM_RBUTTONUP: pm1.Popup(Mouse.CursorPos.x, Mouse.CursorPos.y);
  //
  NIN_BALLOONSHOW:;
  NIN_BALLOONHIDE:      refr_tn;
  NIN_BALLOONTIMEOUT:   refr_tn;
  NIN_BALLOONUSERCLICK: refr_tn;
 end
end;
procedure Tform1.DefaultHandler(var M);
begin
 if TMessage(M).Msg = WM_TASKBARCREATED then begin
  set_tn(0,2,''); set_tn(0,0,'MorzeCODER');end;
 inherited
end;

//---
procedure TForm1.Image1Click(Sender: TObject);
begin
 TIMER1.Enabled:= TRUE
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 with (sender as timage) do top:= top+1
end;
procedure TForm1.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 with (sender as timage) do top:= top-1
end;

procedure TForm1.m1Change(Sender: TObject);
var i,z: integer;
begin
 if m1.Text<>'' then begin
  //
  slovo:= '';
  for i:=1 to length(m1.Text) do begin
   z:= pos(lowercase(m1.Text[i]),letters);
   if z<>0 then slovo:= slovo + codes[z-1] + ' '
    else slovo:= slovo + ' '
  end;
  caption:= ' morze: ' + slovo
 end
end;

procedure TForm1.m1KeyPress(Sender: TObject; var Key: Char);
begin

 if (key=#13) and (m1.Text<>'') then image1.OnClick(nil)
end;

procedure TForm1.m1Click(Sender: TObject);
begin
 m1.Clear;
 caption:= ' CoderMORZE v1.0'
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 SetWindowLong(Application.Handle,GWL_EXSTYLE,GetWindowLong(Application.Handle, GWL_EXSTYLE) or
  not WS_EX_APPWINDOW);
 set_tn(0,0,'MorzeCODER');

 Gen1:= TGen.Create(SELF)
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 set_tn(0,2,'');
 Gen1.FREE
end;

procedure TForm1.N2Click(Sender: TObject);
begin
 close
end;

procedure TForm1.O1Click(Sender: TObject);
var about: string;
begin
 about:= 'C  '#10+
         ' '#10+
         ' '#10+
         '-----------------------------------------------------'#10+
         ':    ';
 //
 show_tn(1,about,'Copyright 2004 CoderMORZE, Inc.')
end;

end.
